```
class Perceptron:
    
    def __init__(self, training_size=100, test_size=1000, dim=2, line_params=(0.5, 1, -1), proportion=1, 
                 W=(0,0,0), eta=0.01, max_iter=100000, stop = 0.001, offset=0.5):
        
        self.X_training = np.insert(proportion*(np.random.rand(training_size, dim) - offset), 0, 1, axis=1)
        self.X_test = np.insert(proportion*np.random.rand(test_size, dim), 0, 1, axis=1)
        
        self.Y_training = np.apply_along_axis(self.classify, 1, self.X_training, line_params)
        self.Y_test = np.apply_along_axis(self.classify, 1, self.X_test, line_params)
        
        self.W = np.array([W])
        self.eta = eta
        self.max_iter = max_iter
        self.stop = stop
        self.proportion = proportion
        self.line_params = line_params
        
        self.test_size = test_size
        self.offset = offset

    
    def classify(self, x, line_params):
        a_0, a_1, a_2 = line_params
        result = a_0 + a_1*x[1] + a_2*x[2]
        if result >= 0:
            return 1
        else:
            return -1
        
    def run(self):
            
        i = 0
        
        while i < self.max_iter:
            
            idx = np.random.randint(0,p.X_training.shape[0],1)
            x = self.X_training[idx]
            y = self.Y_training[idx]
            
            s = np.inner(self.W, x)[0][0]
            

            if y * s <= 1:
                self.W = self.W + self.eta * (y - s) * x
            
            i = i + 1
        
        self.error = np.sum(self.Y_test - np.apply_along_axis(self.classify, 1, self.X_test,self.W[0])) / self.test_size
```